from cryptography.hazmat.backends import default_backend
from cryptography.hazmat.primitives import serialization
from lxml import etree
import xmlsig

def sign(ctx, node):
      """
      Signs a Signature node
      :param node: Signature node
      :type node: lxml.etree.Element
      :return: None
      """
      signed_info = node.find("ds:SignedInfo", namespaces=xmlsig.constants.NS_MAP)
      signature_method = signed_info.find(
          "ds:SignatureMethod", namespaces=xmlsig.constants.NS_MAP
      ).get("Algorithm")
      key_info = node.find("ds:KeyInfo", namespaces=xmlsig.constants.NS_MAP)
      if key_info is not None:
          ctx.fill_key_info(key_info, signature_method)
      #self.fill_signed_info(signed_info)
      ctx.calculate_signature(node)
    
    
saml = etree.parse("saml.xml")
signature = saml.xpath("//ds:Signature", namespaces={"ds": xmlsig.constants.DSigNs})[0]
ctx = xmlsig.SignatureContext()
ctx.key_name = "foo"
with open("RSAPrivateKey01.key", "rb") as key_file:
            ctx.private_key = serialization.load_der_private_key(
                key_file.read(), password=None, backend=default_backend()
            )
            
sign(ctx,signature)
f= open("saml_signed.xml","wb")
f.write(etree.tostring(saml))
f.close()


